﻿var config = require("./configure.js");
var resource = require("./resources.js");
var util = require("util");
var async = require("async");
var security = require("./security.js");
var ejs = require("ejs");
require("date-utils");

var collection = new ProfileCollection();

module.exports = function(app){
	app.get("/profile",list_proc);
	app.get("/profile/admin",admin_proc);
	app.post("/profile/admin",admin_postproc);
	app.get("/profile/detail",detail_proc);
	app.post("/profile/detail",detail_postproc);
	app.post("/profile/edit",edit_postproc); 
	app.get("/profile/registor",registor_proc); 
	app.post("/profile/registor",registor_postproc); 
};

function admin_proc(req, res)
{
	var info = new security.SessionInfomation(true);
	req.session.items = info;
	async.waterfall([
		function(callback){
			PrepaerListAsync(req,callback);
		}
	],function(err,result){
		if(err != null)
			RenderMessage(res,err,info);
		else{
			result.token = info.token;
			res.setHeader("X-FRAME-OPTIONS","DENY");
			res.render("profile/admin",result);
		}
	});
}

function admin_postproc(req,res)
{
	if(req.session.items.token != req.body.token){
		RenderMessage(res,resource.invaild_parameter,req.session.items);
		return;
	}
	async.waterfall([
		function(cb){
			if(typeof(req.body.removeall) != "undefined")
				collection.ClearAsync(cb);
			if(typeof(req.body.remove) != "undefined")
				collection.RemoveRangeAsync(req.body.names,cb);
		}
	],function(err,result){
		if(err != null)
			RenderMessage(res,err,req.session.items);
		else
			RenderMessage(res,resource.success_remove,req.session.items);
	});
}

function list_proc(req, res)
{
	if(typeof(req.session.items) != "undefined")
		req.session.items.admin = false;
	async.waterfall([
		function(cb){
			PrepaerListAsync(req,cb);
		}
	],function(err,result){
		if(err != null)
			RenderMessage(res,err,req.session.items);
		else
			res.render("profile/list",result);
	});
}

function PrepaerListAsync(req,callback)
{
	var limit = config.db_limit;
	var start = 0;
	var parttern = "";
	if(typeof(req.query.start) != "undefined")
		start = parseInt(req.query.start);
	if(typeof(req.query.limit) != "undefined")
		limit = parseInt(req.query.limit);

	async.waterfall([
		function(cb){
			if(typeof(req.query.search) != "undefined")
			{
				parttern = req.query.search;
				collection.FindByNameAsync(parttern,start,limit,cb);
			}else{
				collection.ToArrayAsync(start,limit,cb);
			}
		}
	],function(err,result){
		if(err != null){
			callback(err,null);
		}else{
			var next = start + limit;
			var prev = start - limit;
			if(prev < 0)
				prev = 0;
			for(var i = 0; i < result.length; i++)
				result[i].lastmodified = result[i].lastmodified.toFormat("YYYY/MM/DD HH:MI:SS");
			callback(null,{list:result,search:parttern,next:next,prev:prev,limit:limit});
		}
	});
}

function detail_proc(req, res)
{
	if(typeof(req.query.name) == "undefined")
	{
		RenderMessage(res,resource.invaild_parameter,req.session.items);
		return;
	}

	if(typeof(req.session.items) == "undefined")
		req.session.items = new security.SessionInfomation(false);

	async.waterfall([
		function(cb){
			collection.GetAsync(req.query.name,cb);
		},
	],function(err,result){
		if(err != null)
			RenderMessage(res,err,req.session.items);
		else if(result.length == 0)
			RenderMessage(res,resource.notfound_name,req.session.items);
		else{
			res.setHeader("X-FRAME-OPTIONS","DENY");
			res.render("profile/detail",{list:result,token:req.session.items.token,admin:req.session.items.admin});
		}
	});
}

function detail_postproc(req, res)
{
	if(req.session.items.token != req.body.token){
		RenderMessage(res,resource.invaild_parameter,req.session.items);
		return;
	}
	if(typeof(req.body.remove) != "undefined"){
		async.waterfall([
			function(cb){
				if(typeof(req.session.items) != "undefined" && req.session.items.admin)
					cb(null,true);
				else
					collection.AuthAsync(req.body.name,req.body.password,cb);
			},
			function(result,cb){
				if(result)
					collection.RemoveAsync(req.body.name,cb);
				else
					cb(null,null);
			}
		],function(err,result){
			if(err != null)
				RenderMessage(res,err,req.session.items);
			else if(result == null)
				RenderMessage(res,resource.unmatch_password,req.session.items);
			else
				RenderMessage(res,resource.success_remove,req.session.items);
		});
	}else if(typeof(req.body.edit) != "undefined"){
		async.waterfall([
			function(cb){
				if(typeof(req.session.items) != "undefined" && req.session.items.admin)
					cb(null,true);
				else
					collection.AuthAsync(req.body.name,req.body.password,cb);
			},
			function(result,cb){
				if(result)
					collection.GetAsync(req.body.name,cb);
				else
					cb(null,null);
			}
		],function(err,result){
			if(err != null){
				RenderMessage(res,err,req.session.items);
			}else if(result != null){
				res.setHeader("X-FRAME-OPTIONS","DENY");
				res.render("profile/edit",{list:result,token:req.body.token});
			}else{
				RenderMessage(res,resource.unmatch_password,req.session.items);
			}
		});
	}else{
		RenderMessage(res,resource.invaild_parameter,req.session.items);
	}
}

function edit_postproc(req, res)
{
	if(req.session.items.token != req.body.token){
		RenderMessage(res,resource.invaild_parameter,req.session.items);
		return;
	}
	if(typeof(req.body.name) == "undefined")
	{
		RenderMessage(res,resource.invaild_parameter,req.session.items);
		return;
	}else if(typeof(req.body.edit) != "undefined"){
		async.waterfall([
			function(cb){
				collection.UpdatAsync(req.body.name,req.body,cb);
			}
		],function(err,result){
			if(err != null)
				RenderMessage(res,err,req.session.items);
			else
				RenderMessage(res,resource.success_edit,req.session.items);
		});
	}else{
		RenderMessage(res,resource.invaild_parameter,req.session.items);
	}
}

function registor_postproc(req, res)
{
	if(req.session.items.token != req.body.token){
		RenderMessage(res,resource.invaild_parameter,req.session.items);
		return;
	}
	if(typeof(req.body.registor) != "undefined"){
		async.waterfall([
			function(cb){
				collection.AddAsync(req.body,cb);
			}
		],function(err,result){
			if(err != null)
				RenderMessage(res,err,req.session.items);
			else
				RenderMessage(res,resource.success_registor,req.session.items);
		});
	}else{
		RenderMessage(resource.invaild_parameter,req.session.items);
	}
}

function registor_proc(req, res)
{
	if(typeof(req.session.items) == "undefined")
		req.session.items = new security.SessionInfomation(false);

	res.setHeader("X-FRAME-OPTIONS","DENY");
	res.render("profile/registor",{token:req.session.items.token});
}

function RenderMessage(res,msg,info)
{
	if(typeof(info) == "undefined")
		res.render("profile/message",{message:msg});
	else
		res.render("profile/message",{message:msg,admin:info.admin});
}

//
// ProfileCollectionクラス
//
function ProfileCollection()
{
	var MySQLPool = new require("./mysql_pool.js");
	var pool = new MySQLPool({
				host     : config.db_host,
				user     : config.db_user,
				password : config.db_password,
				port     : config.db_port,
				database : "webchat",
			});
	this.AuthAsync = function(name,password,cb){
		async.waterfall([
			function(next){
				pool.query("SELECT * FROM list WHERE name = ?",[name],next);
			},
			function(result,next){
				if(result[0].password == password)
					next(null,true);
				else
					next(null,false);
			}
		],cb);
	}
	this.GetAsync = function(name,cb){
		pool.query("SELECT * FROM list WHERE name = ?",[name],cb);
	}
	this.AddAsync = function(data,cb){
		var item = {
			name:data.name,
			age:data.age,
			gender:data.gender,
			height:data.height,
			weight:data.weight,
			race:data.race,
			password:data.password,
			lastmodified:new Date(),
			etc:data.etc
		};
		pool.query("INSERT INTO list SET ?",[item],cb);
	}
	this.UpdatAsync = function(name,data,cb){
		var item = {
			name:data.name,
			age:data.age,
			gender:data.gender,
			height:data.height,
			weight:data.weight,
			race:data.race,
			password:data.password,
			lastmodified:new Date(),
			etc:data.etc
		};
		pool.query("UPDATE list SET ? WHERE name = ?",[item,name],cb);
	}
	this.ClearAsync = function(cb){
		pool.query("TRUNCATE TABLE list",null,cb);
	}
	this.RemoveRangeAsync = function(names,cb){
		pool.query("DELETE FROM list WHERE name IN (?)",[names],cb);
	}
	this.RemoveAsync = function(name,cb){
		pool.query("DELETE FROM list WHERE name = ?",[name],cb);
	}
	this.FindByNameAsync = function(pattern,start,count,cb){
		pool.query("SELECT * FROM list WHERE name LIKE ? LIMIT ?,?",[pattern+"%",start,count],cb);
	}
	this.ToArrayAsync = function(start,count,cb){
		pool.query("SELECT name,age,lastmodified FROM list LIMIT ?,?",[start,count],cb);
	}
}

